xfs
[Top] [All Lists]

[PATCH] xfstests: add test for renaming over non-empty directories

To: xfs@xxxxxxxxxxx
Subject: [PATCH] xfstests: add test for renaming over non-empty directories
From: Christoph Hellwig <hch@xxxxxxxxxxxxx>
Date: Thu, 28 Oct 2010 07:52:24 -0400
User-agent: Mutt/1.5.21 (2010-09-15)
Per Posix renames over non-empty directories should fail, but hfsplus used to
allow this (and corrupt the filesystem while doing so).

Signed-off-by: Christoph Hellwig <hch@xxxxxx>

Index: xfstests-dev/245
===================================================================
--- /dev/null   1970-01-01 00:00:00.000000000 +0000
+++ xfstests-dev/245    2010-10-28 11:46:52.000000000 +0000
@@ -0,0 +1,65 @@
+#! /bin/bash
+# FS QA Test No. 245
+#
+# Check that directory renames onto non-empty targets fail
+#
+# Based on a bug report and testcase from  Vlado Plaga <rechner@xxxxxxxxxxx>
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2010 Christoph Hellwig.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#
+#-----------------------------------------------------------------------
+#
+# creator
+owner=hch@xxxxxx
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1       # failure is the default!
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+
+dir=$TEST_DIR/test-mv
+
+_cleanup()
+{
+       rm -rf $dir
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+
+mkdir $dir
+
+mkdir $dir/aa
+mkdir $dir/ab
+touch $dir/aa/1
+mkdir $dir/ab/aa
+touch $dir/ab/aa/2
+
+mv $dir/ab/aa/ $dir 2>&1 | _filter_test_dir
+
+status=0
+exit $status
Index: xfstests-dev/245.out
===================================================================
--- /dev/null   1970-01-01 00:00:00.000000000 +0000
+++ xfstests-dev/245.out        2010-10-28 11:45:48.000000000 +0000
@@ -0,0 +1,2 @@
+QA output created by 245
+mv: cannot move `TEST_DIR/test-mv/ab/aa/' to `TEST_DIR/test-mv/aa': File exists
Index: xfstests-dev/group
===================================================================
--- xfstests-dev.orig/group     2010-10-21 04:56:28.000000000 +0000
+++ xfstests-dev/group  2010-10-28 11:45:48.000000000 +0000
@@ -358,3 +358,4 @@ deprecated
 242 auto quick prealloc
 243 auto quick prealloc
 244 auto quota quick
+245 auto quick dir

<Prev in Thread] Current Thread [Next in Thread>
  • [PATCH] xfstests: add test for renaming over non-empty directories, Christoph Hellwig <=